#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityDoubleElevenDiamondGift.h"
std::auto_ptr<M_ActivityDoubleElevenDiamondGift> M_ActivityDoubleElevenDiamondGift::msSingleton(nullptr);

int M_ActivityDoubleElevenDiamondGift::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDoubleElevenDiamondGiftData* M_ActivityDoubleElevenDiamondGift::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityDoubleElevenDiamondGiftData>& M_ActivityDoubleElevenDiamondGift::GetMapData()
{
	return mMapData;
}

void M_ActivityDoubleElevenDiamondGift::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityDoubleElevenDiamondGift.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDoubleElevenDiamondGiftData data;
		data.mID = element->IntAttribute("ID");
		data.mFlushTime = element->IntAttribute("FlushTime");
		data.mGift1Count = element->IntAttribute("Gift1Count");
		data.mGift2Count = element->IntAttribute("Gift2Count");
		data.mGift3Count = element->IntAttribute("Gift3Count");
		data.mGiftId = element->IntAttribute("GiftId");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityDoubleElevenDiamondGift Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDoubleElevenDiamondGift::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityDoubleElevenDiamondGift");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityDoubleElevenDiamondGift");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityDoubleElevenDiamondGiftData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "FlushTime", data.mFlushTime);
		LuaCfgHelper::readInt(L, "Gift1Count", data.mGift1Count);
		LuaCfgHelper::readInt(L, "Gift2Count", data.mGift2Count);
		LuaCfgHelper::readInt(L, "Gift3Count", data.mGift3Count);
		LuaCfgHelper::readInt(L, "GiftId", data.mGiftId);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityDoubleElevenDiamondGift Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDoubleElevenDiamondGift::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityDoubleElevenDiamondGift* M_ActivityDoubleElevenDiamondGift::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDoubleElevenDiamondGift());
	}
	return msSingleton.get();
}

void M_ActivityDoubleElevenDiamondGift::Release()
{
	msSingleton.reset(nullptr);
}
